' Compiler Utility for Rapid-Q
' CodeBox  Version 1.0
' this source file needs folder.bmp

'$OPTION BYTECODE
$TypeCheck ON
$Include "rapidq.inc"

CONST msgError_Ok=16   ' for messagebox

$TypeCheck ON

'AAAAAAAAAAAAAAAH I forgot CGI!
' Oh well,
' Maybe in the next release...
DECLARE SUB OpenSource (Sender AS QCOOLBTN)
DECLARE SUB MakeItWindows (Sender AS QRADIOBUTTON)
DECLARE SUB MakeItGTK (Sender AS QRADIOBUTTON)
DECLARE SUB MakeItConsole (Sender AS QRADIOBUTTON)
DECLARE SUB RunExe (Sender AS QCHECKBOX)
DECLARE SUB ChangeIncPath
DECLARE SUB ChangeLibPath
DECLARE SUB UseBytecode (Sender AS QCHECKBOX)
DECLARE SUB DoCompile (Sender AS QBUTTON)
DECLARE SUB ExitNow (Sender AS QBUTTON)
DECLARE SUB UseIcon (Sender AS QBUTTON)
Declare Sub FocusForm
Declare sub DoNotRunEXE(Sender as QCHECKBOX)
Declare sub EditSetup(Sender as qbutton)
declare sub DisableSetup(Sender as qbutton)
declare sub NoByteCode(Sender as QCheckBox)
declare sub SetSetup

$Resource SourceFolder as "00139sm.bmp"

static Bytecode as string:static AppInfo as string:static IconInfo as string
static LibPath as string:static IncludePath as string
static RunAfterCompile as integer

CREATE Form AS QFORM
    Caption = "CodeBox"
    Width = 576
    Height = 227
    Center
    BorderStyle=bsDialog
    CREATE Label3 AS QLABEL
        Caption = "main source:"
        Left = 8
        Top = 8
        Width = 60
        Transparent = 1
    END CREATE
    CREATE CoolBtn1 AS QCOOLBTN
        BMPHandle = SourceFolder
        Left = 338
        Top = 7
        Width = 23
        Height = 22
        Flat = 1
        ShowHint = 1
        Hint = "open source"
        OnClick = OpenSource
    END CREATE
    CREATE Panel1 AS QPANEL
        Left = 384
        Top = 8
        Width = 177
        Height = 153
        BevelOuter = 1
        TabOrder = 7
        CREATE RichEdit1 AS QRICHEDIT
            BorderStyle = 0
            Left = 1
            Top = 1
            Width = 175
            Height = 151
            Align = 5
            ReadOnly = 1
            HideScrollbars=0
            ScrollBars=ssVertical
        END CREATE
    END CREATE
    CREATE GroupBox1 AS QGROUPBOX
        Caption = "App&Type"
        Left = 8
        Top = 72
        Width = 361
        Height = 121
        TabOrder = 4
        CREATE Label1 AS QLABEL
            Caption = "Change include path:"
            Left = 8
            Top = 76
            Width = 100
        END CREATE
        CREATE Label2 AS QLABEL
            Caption = "Change library path:"
            Left = 8
            Top = 95
            Width = 117
        END CREATE
        CREATE RadioButton1 AS QRADIOBUTTON
            Caption = "&GUI (Windows)"
            Left = 8
            Top = 24
            ShowHint = 1
            Hint = "create an application for windows"
            Checked = 1
            OnClick = MakeItWindows
        END CREATE
        CREATE RadioButton2 AS QRADIOBUTTON
            Caption = "GT&K (Linux)"
            Left = 8
            Top = 40
            ShowHint = 1
            Hint = "create an application for linux"
            TabOrder = 1
            OnClick = MakeItGTK
        END CREATE
        CREATE RadioButton3 AS QRADIOBUTTON
            Caption = "C&onsole"
            Left = 8
            Top = 56
            ShowHint = 1
            Hint = "create a console program"
            TabOrder = 2
            OnClick = MakeItConsole
        END CREATE
        CREATE CheckBox3 AS QCHECKBOX
            Caption = "&Autorun"
            Left = 128
            Top = 24
            ShowHint = 1
            Hint = "run immediately after compiling"
            TabOrder = 3
            OnClick = RunExe
        END CREATE
        CREATE IncPathText AS QEdit
            Left = 120
            Top = 72
            Width = 220
            TabOrder = 4
        END CREATE
        CREATE LibPathText AS QEdit
            Left = 120
            Top = 93
            Width = 220
            TabOrder = 5
        END CREATE
    END CREATE
    CREATE CheckBox2 AS QCHECKBOX
        Caption = "CheckBox2"
        Left = -199
        Top = -145
        TabOrder = 5
    END CREATE
    CREATE Edit1 AS QEDIT
        Text = ""
        Left = 72
        Top = 8
        Width = 265
        ShowHint = 1
        Hint = "main source code to compile"
    END CREATE
    CREATE CheckBox1 AS QCHECKBOX
        Caption = "Compile as &byte-code only"
        Left = 136
        Top = 112
        Width = 153
        ShowHint = 1
        Hint = "create a bc source file"
        TabOrder = 6
        OnClick = UseBytecode
    END CREATE
    CREATE Button3 AS QBUTTON
        Caption = "&Compile"
        Left = 72
        Top = 40
        ShowHint = 1
        Hint = "time to make that code do something!"
        TabOrder = 1
        OnClick = DoCompile
    END CREATE
    CREATE Button4 AS QBUTTON
        Caption = "E&xit"
        Left = 264
        Top = 40
        ShowHint = 1
        Hint = "exit"
        TabOrder = 3
        OnClick = ExitNow
    END CREATE
    CREATE Button5 AS QBUTTON
        Caption = "&Icon"
        Left = 168
        Top = 40
        ShowHint = 1
        Hint = "icon for your app (NOTE: Your icon must reside in the same directory)"
        TabOrder = 2
        OnClick = UseIcon
    END CREATE
    CREATE Button6 AS QBUTTON
        Caption = "&Edit"
        Left = 392
        Top = 168
        TabOrder = 8
        OnClick=EditSetup
    END CREATE
    CREATE Button7 AS QBUTTON
        Caption = "&Setup"
        Left = 480
        Top = 168
        TabOrder = 9
        ShowHint=1
        Hint="preview command line"
        OnClick=SetSetup
    END CREATE
END CREATE

'Oh Shoot! The big problem with my bugs is the spaces that I
'forget to include with the command line
'not this ""
'but THIS " "

'--------- Subroutines ---------

SUB OpenSource (Sender AS QCOOLBTN)
Create OpenSource as QOpenDialog
Filter="Rapid-Q source files|*.bas;*.rq;*.rqb"
InitialDir=CurDir$
End Create

if OpenSource.execute then 
Edit1.text=OpenSource.filename
end if
END SUB

SUB MakeItWindows (Sender AS QRADIOBUTTON)
AppInfo=" "+"-GUI"+" "
END SUB

SUB MakeItGTK (Sender AS QRADIOBUTTON)
AppInfo=" "+"-o"+" " 'GTK (Linux)
END SUB

SUB MakeItConsole (Sender AS QRADIOBUTTON)
AppInfo=" "+"-CONS"+" " 'Console
END SUB

SUB RunExe (Sender AS QCHECKBOX)
RunAfterCompile=1
Sender.OnClick=DoNotRunExe
END SUB

SUB DoNotRunEXE(Sender as QCHECKBOX)
RunAfterCompile=0
Sender.OnClick=RunExe
End SUB

SUB ChangeIncPath
if IncPathText not="" then
IncludePath=" "+"-I"+IncPathText.text+" "
else
IncludePath=" "+"-I"+CurDir$+" "
end if
END SUB

SUB ChangeLibPath
if LibPathText not="" then
LibPath=" "+"-L"+LibPathText.text+" "
else
LibPath=" "+"-L"+CurDir$+" "
end if
END SUB

SUB UseBytecode (Sender AS QCHECKBOX)
ByteCode="-b" 'yes
Sender.OnClick=NoBytecode
END SUB

Sub NoBytecode(Sender as QCheckBox)
ByteCode=""
Sender.OnClick=UseByteCode
End Sub

SUB UseIcon (Sender AS QBUTTON)
Create OpenIcon as QOpenDialog
filter="Icon files|*.ico"
InitialDir=CurDir$
End Create

if OpenIcon.execute then
'for some reason I have to reset it
IconInfo=" "+"-g"+OpenIcon.filename+" "
end if
END SUB

SUB DoCompile (Sender AS QBUTTON)
call ChangeIncPath
call ChangeLibPath
IncludePath=" "+"-I"+CurDir$+" "  'command line
LibPath=" "+"-L"+CurDir$+" "
if Edit1.text not="" and if FileExists(Edit1.text)=1 then
Shell(CurDir$+"/rc.exe "+Edit1.text+AppInfo+" "+ _
bytecode+" "+IconInfo+" "+IncludePath+" "+LibPath)
else
MessageBox("You need to type in a valid source file first", _
"Uh oh...",msgError_Ok)
end if

if RunAfterCompile then run Edit1.text+".exe"-".bas"-".rq"-".rqb" end if
END SUB

SUB ExitNow (Sender AS QBUTTON)
form.close
END SUB

SUB EditSetup(Sender as Qbutton)
RichEdit1.ReadOnly=0
Sender.OnClick=DisableSetup
End sub

Sub DisableSetup(Sender as Qbutton)
RichEdit1.ReadOnly=1
Sender.OnClick=EditSetup
End Sub

sub SetSetup
with RichEdit1

if AppInfo not="" then 
.AddStrings AppInfo
else
end if

if Bytecode not="" then 
.AddStrings Bytecode
else
end if
.AddStrings IconInfo
.AddStrings IncludePath
.AddStrings LibPath
end with
end sub
form.showmodal